package org.implab.gradle.containers.cli;

import java.io.Serializable;
import java.util.Optional;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;

public class ImageName implements Serializable {

    private static final long serialVersionUID = -1990105923537254552L;

    final String authority;

    final String name;

    final String tag;

    public ImageName() {
        name = null;
        authority = null;
        tag = null;
    }

    @JsonCreator(mode = JsonCreator.Mode.PROPERTIES)
    private ImageName(@JsonProperty("authority") String authority, @JsonProperty("name") String name,
            @JsonProperty("tag") String tag) {
        this.authority = authority;
        this.name = name;
        this.tag = tag;
    }

    public String getAuthority() {
        return authority;
    }

    public ImageName authority(String authority) {
        return new ImageName(authority, name, tag);
    }

    public String getName() {
        return name;
    }

    public ImageName name(String name) {
        return new ImageName(authority, name, tag);
    }

    public String getTag() {
        return tag;
    }

    public ImageName tag(String tag) {
        return new ImageName(authority, name, tag);
    }

    public ImageName copy() {
        return new ImageName(authority, name, tag);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();

        Optional.ofNullable(authority).ifPresent(s -> sb.append(s).append("/"));
        Optional.ofNullable(name).ifPresent(s -> sb.append(s));
        Optional.ofNullable(tag).ifPresent(s -> sb.append(":").append(s));

        return sb.toString();
    }
}
